<?php
// $Id:  $

/**
 * Drush integration addon for workflow_post_install
 */

/**
 * Implementation of hook_drush_help()
 */
function workflow_post_install_drush_help($command) {
  switch($command) {
    case 'drush:workflow-post-install-create-state':
      return dt('Makes existing nodes without a current workflow state have a given new workflow state.');
  }
}

/**
 * Implementation of hook_drush_command()
 */
function workflow_post_install_drush_command($command) {
  $items = array();
  
  $items['workflow-post-install-create-state'] = array(
    'description' => dt('Makes existing nodes without a current workflow state have a given new workflow state.'),
    'arguments' => array(
      'new_state' => dt('New workflow state name'),
      'published' => dt('Node state to filter on.  0=update unpublished nodes, 1=update published nodes, -1=update all nodes'),
    ),
    'aliases' => array('wpi-cs'),
  );
  
  return $items;
}

/**
 * Implementation of callback for workflow-post-install-create-state command
 */
function drush_workflow_post_install_workflow_post_install_create_state($new_state, $published=-1) {

  $pub = false;
  if ($published == -1) {
    $pub = NULL;
  }
  elseif ($published == 1) {
    $pub = true;
  }
  
  drush_log(dt('Executing push of stateless nodes to "@state" state.', array('!count' => $r, '@state' => $state_name)), 'status');
  $r = workflow_create_state_for_stateless_nodes($new_state, $pub);

  if ($r > 0) {
    drush_log(dt('!count node(s) were put in the "@state" state.', array('!count' => $r, '@state' => $state_name)), 'status');
    drush_log(dt('The content access permissions need to be rebuilt.'), 'warning');
  }
  elseif ($r == 0) {
    drush_log(dt('!count node(s) were put in the "@state" state.', array('!count' => $r, '@state' => $state_name)), 'status');
    drush_log(dt('All workflow-related content already has states assigned.'), 'warning');
  }
  elseif ($r == -1) {
    drush_log(dt('Invalid workflow state: "@state"', array('@state' => $state_name)), 'error');
  }
  
}
